Clementine.API = (function (){
	var me = {},
		_port = 7864;
		
	me.SetLocalHostPort = function (port) {
		_port = port;
	}
	
	me.OpenContact = function (id) {
		_sendApiCall({
			action	: 'load',
			type	: 'Employee',
			id		: id
		});
	};
	
	me.PageRendered = function () {
		_sendApiCall({
			action	: 'display',
			type	: 'Webview'
		});
	};
	
	me.RetrySendMessage = function (id) {
		_sendApiCall({
			action	: 'retry',
			type	: 'Message',
			id		: id
		});
	};
	
	/*
		// example of how to use api that returns data
		for(var id in _participants) {
			Cl.API.GetEmployee(id, function (data) {
				var participant = data;
				Cl.Log(participant.id + ' ' + participant.email);
			});
		}

	*/
	me.GetEmployee = function (id, callback) {
		_sendApiCall({
			action	: 'get',
			type	: 'Employee',
			id		: id
		}, callback);
		
	};
	
	// Logs in xamarin studio console. Useful for debugging webview in simulator or devices
	me.Log = function (str) {
		_sendApiCall({
			action	: 'log',
			msg		: str
		});
	}
	
	function _sendApiCall(params, callback) {
		var url = 'http://127.0.0.1:' + _port + '/';	
		$.ajax({
			dataType: "json",
			url: url,
			data: params,
			success: function(data, textStatus, jqXHR) {
				if (typeof callback ===  'function') {
					callback(data);
				}
			}
		});
	}
	
	return me;
}());