Cl.htmlEcnoder = (function() {
	var that = {};

	that.urlRegex = /(\(?\bhttps?:\/\/[-A-Za-z0-9+&@#/%?=~_()|!:,.;]*[-A-Za-z0-9+&@#\/%=~_()|])|([&<>"])/ig; //" this screw up editer syntax highlight
	that.youtubeRegex = /.*(?:youtu.be\/|v\/|u\/\w\/|embed\/|watch\?v=)([^#\&\?]*).*/i;
	that.telRegex = /(\(?\btel?:[-0-9+,;#*]*)/ig;
	that.imgExtensions = ['jpg', 'png', 'gif', 'jpeg'];
	
	function _endsWith(str, suffix) {
	    return str.indexOf(suffix, str.length - suffix.length) !== -1;
	}
	
	// this method will replace url with <a> and imoticon with images
	that.parseMessage = function(str) {
		// regex to detect web url and make it as a link
	    str = str.replace(that.urlRegex, function(m) {
	    	var mlower = m.toLowerCase();
	    
	    	if (mlower.indexOf("http")==0) {
	    		// is this an image?
	    		for (var i in that.imgExtensions) {
	    			if (_endsWith(mlower, that.imgExtensions[i])) {
	    				return '<a class="embedImg" href="' + m + '"><img src="' + m + '" /></a>';
	    			}
	    		}
	    		// is this a youtube?
	    		if (mlower.indexOf("youtube.com") !== -1 || mlower.indexOf("youtu.be") !== -1) {
	    			var match = m.match(that.youtubeRegex);
	    			if (match && match[1].length==11){
	    				var youtubeTnailUrl = 'http://img.youtube.com/vi/' + match[1] + '/mqdefault.jpg';
	    				
	    				return '<div class="youtube"><img src="' + youtubeTnailUrl + '"/><a href="' + m + '"></a></div>';
	    				//return '<div class="youtube"><a href="' + m + '"><img src="' + youtubeTnailUrl + '"/></a></div>';
	    				//return '<a class="embedImg" href="' + m + '"><img src="' + youtubeTnailUrl + '" /></a>';
	    			}
	    		}
	    		
	    		// just a link
	    		return '<a href="' + m + '">' + m + '</a>';
		    } else if (m == "&")
		    	return "&amp;";
		    else if (m == "<")
		    	return "&lt;";
		    else if (m == ">")
		    	return "&gt;";
		    else if (m == '"')
		    	return "&quot;";
	    });
	    
	    str = str.replace(that.telRegex, function (m) {
		    console.log(m);
		    return '<a href="' + m + '">' + m.substring(4) + '</a>'
	    });
	    
	    str = str.replace(/\n/ig, function(m) {
		   return '<br/>'; 
	    });
	    
	    return str;
	};
	
	return that;
}());